#include "rkan.h"

/*        Categories database        */
/* M.Fleming, R.Gunther, R.Rosebrugh */
/* Mount Allison University 1994-95  */

struct coinc_node
	{
	int x;
	int y;
	int obj;
	struct coinc_node *next;
	};

typedef struct
	{
	struct coinc_node *head;
	struct coinc_node *tail;
	} coinc_list;

extern void left_kan(category_list, functor_list, int);
extern void initialize_e_table(int, int);
extern void add_to_e_table(int, int, int);
extern void display_e_table(int,FILE*);
extern int undefined(int);
extern void initialize_L_table(int,int);
extern void initialize_rel_table(int,int,int);
extern void add_L_table_row(int, int, int[MAXWORD]);
extern void add_rel_table_row(int,int,int,int[MAXWORD],int[MAXWORD]);
extern void add_to_L_table(int, int, int, int);
extern void display_L_table(int,FILE*);
extern int least_unused(int);
extern void define_L(void);
extern void display_rel_table(int,FILE*);
extern void initialize_nat_tables(int,int,int);
extern void display_nat_table(int,FILE*);
extern void add_to_all_rel(int,int);
extern void update_nat(int,int,int);
extern void check_coinc(struct nodetype*, struct nodetype*);
extern void add_coinc(int,int,int);
extern void reverse(int[MAXWORD],int[MAXWORD]);
extern void fill_conseq_rel(void);
extern void fill_conseq_nat(void);
extern void deal_with_coinc(void);
extern void update_coinc_list(int,int,int);
extern void display_coincs(void);
extern void delete_row(int,int);
extern void check_coinc_2(int,int,int);
extern void update_e(int,int,int);
extern void update_L(int,int,int);
extern int num_coincs(void);
extern void remove_redundancies(void);
extern void delete_rel_row(int,int);
extern bool already_coinc(int,int,int);
extern void renumber(void);
extern void renum(struct nodetype*[MAXWORD],int,int,int,int,int);
extern void free_row(struct nodetype*);
